#include <QTRSensors.h>

#define Kp 0.02 // experiment to determine this, start by something small that just makes your bot follow the line at a slow speed
#define Kd 0 // experiment to determine this, slowly increase the speeds and adjust this value. ( Note: Kp < Kd) 
#define rightMaxSpeed 100 // max speed of the robot
#define leftMaxSpeed 100 // max speed of the robot
#define rightBaseSpeed 80 // this is the speed at which the motors should spin when the robot is perfectly on the line
#define leftBaseSpeed 80  // this is the speed at which the motors should spin when the robot is perfectly on the line
#define NUM_SENSORS  6  // number of sensors used
#define TIMEOUT       3000  // waits for 2500 us for sensor outputs to go low
#define EMITTER_PIN   2     // emitter is controlled by digital pin 2

#define rightMotor1 9
#define rightMotor2 8
#define rightMotorPWM 10
#define leftMotor1 6
#define leftMotor2 7
#define leftMotorPWM 5



QTRSensors qtr;
const uint8_t SensorCount = 6;
uint16_t sensorValues[SensorCount];


void setup()
{
  pinMode(rightMotor1, OUTPUT);
  pinMode(rightMotor2, OUTPUT);
  pinMode(rightMotorPWM, OUTPUT);
  pinMode(leftMotor1, OUTPUT);
  pinMode(leftMotor2, OUTPUT);
  pinMode(leftMotorPWM, OUTPUT);

  
   qtr.setTypeRC();
qtr.setSensorPins((const uint8_t[]){A0, A1, A2, A3, A4,12}, SensorCount);
qtr.setEmitterPin(2);

// 2.5 ms RC read timeout (default) * 10 reads per calibrate() call
  // = ~25 ms per calibrate() call.
  // Call calibrate() 400 times to make calibration take about 10 seconds.
  for (uint16_t i = 0; i < 400; i++)
  {
    qtr.calibrate();
  }
  digitalWrite(LED_BUILTIN, LOW); // turn off Arduino's LED to indicate we are through with calibration

  // print the calibration minimum values measured when emitters were on
  //Serial.begin(9600);
  //for (uint8_t i = 0; i < SensorCount; i++)
  //{
    //Serial.print(qtr.calibrationOn.minimum[i]);
    //Serial.print(' ');
  //}
  //Serial.println();

  // print the calibration maximum values measured when emitters were on
  //for (uint8_t i = 0; i < SensorCount; i++)
  //{
    //Serial.print(qtr.calibrationOn.maximum[i]);
    //Serial.print(' ');
  //}
  //Serial.println();
  //Serial.println();
  //delay(1000);
Serial.begin(9600);
delay(4000); // wait for 2s to position the bot before entering the main loop 
    
   
  } 

int lastError = 0;
int I=0;
int P;
int D;

void loop()
{
 uint16_t position = qtr.readLineBlack(sensorValues);

  // print the sensor values as numbers from 0 to 1000, where 0 means maximum
  // reflectance and 1000 means minimum reflectance, followed by the line
  // position
  for (uint8_t i = 0; i < SensorCount; i++)
 {
    Serial.print(sensorValues[i]);
    Serial.print('\t');
  }
  Serial.println(position);
  Serial.print('\t');
  int error = position - 3500;
  Serial.println(error);
  P = error;
 D = error - lastError;
 // I = I+P;

  int PIDvalue = (Kp * P)+(Kd *D) ;
  lastError = error;

  int rightMotorSpeed = rightBaseSpeed + PIDvalue;
  int leftMotorSpeed = leftBaseSpeed - PIDvalue;
  
    if (rightMotorSpeed > rightMaxSpeed ) rightMotorSpeed = rightMaxSpeed; // prevent the motor from going beyond max speed
  if (leftMotorSpeed > leftMaxSpeed ) leftMotorSpeed = leftMaxSpeed; // prevent the motor from going beyond max speed
  if (rightMotorSpeed < 0) rightMotorSpeed = 0; // keep the motor speed positive
  if (leftMotorSpeed < 0) leftMotorSpeed = 0; // keep the motor speed positive
   Serial.println(rightMotorSpeed);
    Serial.println(leftMotorSpeed);
   {
   // move forward with appropriate speeds
  digitalWrite(rightMotor1, HIGH);
  digitalWrite(rightMotor2, LOW);
  analogWrite(rightMotorPWM, rightMotorSpeed);

  digitalWrite(leftMotor1, HIGH);
  digitalWrite(leftMotor2, LOW);
  analogWrite(leftMotorPWM, leftMotorSpeed);
 
}
}
  
void wait(){
   // digitalWrite(motorPower, LOW);
  }
